Subject: Routing: @action should not be case sensitive

Description

With the default routing setup, following is (and should be) possible:

http://localhost/TestinG/sTanDard/inDeX

However

http://localhost/testing/standard/Index

throws an exception

#1218473352: The action name must start with a lower case letter, "Index" does not match this criteria.

That should not happen.

| suggest to lower case all MVC parameters in the Router already, so that the request contains the same keys independently from the
spelling.

Patch follows

Related issues:
related to TYPOS.Flow - Feature # 2237: URLs can only be lowercase Resolved 2008-11-27

Associated revisions

Revision a11f255e - 2009-10-30 14:32 - Karsten Dambekalns

[+BUGFIX] FLOW3 (MVC): MVC parameters (package key, controller name, action name, format) are now lowercased before set in the request, fixes
#5182.

History

#1 - 2009-10-30 13:37 - Bastian Waidelich
- File 5182_action_should_not_be_case_sensitive.patch added
- Assigned To changed from Bastian Waidelich to Karsten Dambekalns

Attached patch fixes the issue by lower-casing all MVC parameters (@package, @subpackage, @controller & @action) before storing them in the
request object.
Note: @format is not lower cased yet, cause I'm not sure about the implications: Maybe someone wants to have somethink like

"http://localhost/myroute.RSS" - does that make sense?

#2 - 2009-10-30 14:13 - Bastian Waidelich
- File 5182_action_should_not_be_case_sensitive_v2.patch added
- Target version set to 1.0 alpha 6

v2 of the patch also lower cases format and uses native strtolower() instead of the PHP6-methods, as discussed with Karsten

#3 - 2009-10-30 14:16 - Bastian Waidelich
- File 5182_action_should_not_be_case_sensitive_v3.patch added

v2 contained changes from another patch, sorry.

#4 - 2009-10-30 14:25 - Karsten Dambekalns

Bastian Waidelich wrote:

uses native strtolower() instead of the PHP6-methods, as discussed with Karsten

The rationale (for the record): Since those parts (package key, controller, action) reflect class and method names they cannot be unicode in PHP

currently. As soon as they can be, strtolower() can be expected to be able to deal with that.

#5 - 2009-10-30 15:00 - Karsten Dambekalns
- Status changed from Accepted to Resolved
- % Done changed from 0 to 100

Applied in changeset r3384.

Files

5182_action_should_not_be_case_sensitive.patch 6.2 kB 2009-10-30 Bastian Waidelich
5182_action_should_not_be_case_sensitive_v2.patch 6.9 kB 2009-10-30 Bastian Waidelich
5182_action_should_not_be_case_sensitive_v3.patch 6.1 kB 2009-10-30 Bastian Waidelich
